print("Map Object Handling Loading.")

--Make the console vars to control this feature
local EnableLagRemoval = CV_RegisterVar({ --make a console variable to control whether intermission teamchange is blocked or not
	name = "tu_removelaggyobjects",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

--This function handles ctf ring monitors, converts them to normal monitors
local function changeToSuperRing(mobj)
	if not TagUtilities.isTag then
		return
	end
	local xcord,ycord,zcord = mobj.x,mobj.y,mobj.z
	P_RemoveMobj(mobj)
	P_SpawnMobj(xcord, ycord, zcord, MT_RING_BOX)
end

--Made a function to handle mobj deletion
local function removeObjects(mobj)
	if EnableLagRemoval.value == 1 then
		P_RemoveMobj(mobj)
	end
end

--made another function to quickly define hooks
--only ever run this on addon load
local function fastMobjHook(mobjType)
	addHook("MobjThinker", function(mobj) 
		removeObjects(mobj)
	end,
	mobjType)
end


--These hooks are for the ring monitors
addHook("MobjThinker", function(mobj) 
	changeToSuperRing(mobj)
end,
MT_RING_REDBOX)

addHook("MobjThinker", function(mobj) 
	changeToSuperRing(mobj)
end,
MT_RING_BLUEBOX)



--These hooks are for the problematic mobjs, delete them if the admin wants to
--fastMobjHook(MT_TNTBARREL)
--fastMobjHook(MT_PROXIMITYTNT)
fastMobjHook(MT_SPINDUST)
fastMobjHook(MT_SMOKE)
fastMobjHook(MT_ARIDDUST)
fastMobjHook(MT_TNTDUST)
fastMobjHook(MT_FLAMEPARTICLE)
fastMobjHook(MT_BIGTUMBLEWEED)
fastMobjHook(MT_LITTLETUMBLEWEED)


print("Map Object Handling finished Loading.")