print("Mario Bros Tweaks Loading.")

--Just don't load any of this if mario doesn't exist
if not MARIOSHIELDS then
	print("Mario Bros not detected! Mario Tweaks cancelled loading!")
	return
end

--Making a console variable to enable or disable ring drain
local allowRingDrain = CV_RegisterVar({
	name = "tu_mariobrosringdrain",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

local isItABro = {
		mario = true,
		luigi = true
	}
	
--variable that holds the ticrate of ring drain
local defaultRingDrainTics = 1 * TICRATE



--empty table that will be defined later
--Basically we need to store the shield values in Mario Bros, however those
--are constants defined in that addon. For some reason, trying to refer to
--addon constants don't work on load, so we have to do this once the game has
--finished loading, and that it runs for every player online.
local ringDrainShields = {}

--bullshit function that fixes resyncs
--Dealing with external variables made by other addons require me to
--set them again during a hook event for it to sync
--idfk whyyyyyy
local function defineKeyData()
	--this disables Kuribo's shoe
	MARIOSHIELDS[SH_SHOE] = nil
	SH_SHOE = INT8_MIN

	--another table to check which mario powerups or shields should have ring drain.
	--key is the shield flag, value is the name of the shield in string form
	--doubles as a nil check and a table to insert specific text with
	ringDrainShields = {
		[SH_BALLOON] = "P-Balloon",
		[SH_CAPE] = "Wing Cape",
		[SH_MINI] = "Mini Mushroom"
	}
end

--oh yeah define it now once the addon loads
defineKeyData()


--another function to handle the removal of the proper shield
local function removeShield(player, shieldCheck)
	--player.powers[pw_shield] = 0
	P_SwitchShield(player, SH_NONE)
	chatprintf(player, "You ran out of rings, no more " .. shieldCheck .. "...")
end

--make sure the player exists and is a mario bro
local function nilAndbroCheck(player)
	--obligatory nil check
	if player.mo == nil then
		return false
	--we don't care if player is a tagger or not a bro
	--(player.pflags & PF_TAGIT) or
	elseif isItABro[player.mo.skin] == nil then
		return false
	end
	return true
end

--mini mushroom has ring drain now
--also other powerups but too lazy to change name
local function ringDrainPower(player)
	 if not nilAndbroCheck(player) then
		return
	end
	
	--Player is not nil, is a mario bro, and is IT.
	--The code will continue now assuming all the above.
	
	--Do the shield check now to save an instruction
	local shieldCheck = ringDrainShields[player.powers[pw_shield]]
	--player is both a hider and playing a mario bro, execute the code
	if shieldCheck == nil then
		--not using a ring drain enabled shield, return
		return
	end
	
	--remove mini mush if the ring count is zero
	if player.rings > 0 then
	--remove a ring and reset tics
		player.rings = $ - 1
	else
		--call the shield removal function
		removeShield(player, shieldCheck)
	end
end

--another function to handle the outside of ringDrainMini
local function preRingDrain()
--Check if ringdrain is enabled before running code
	if allowRingDrain.value == 1 then
		for player in players.iterate do
			ringDrainPower(player)
		end
	end
end

addHook("PostThinkFrame", function()
	--check if the level time is on a ring drain frame.
	if leveltime % defaultRingDrainTics == 0 then
		preRingDrain()
	end
end)

addHook("PlayerThink", function(player)
	--Check if the player got a megamushroom, if they do then turn it off and give sneakers.
	if TagUtilities.isTag and player.mariomega then
		player.mariomega = 0
		A_SuperSneakers(player.mo)
	end
end)

--This bullshit stops resyncs, handling external variables fucks shit up
addHook("PlayerJoin", defineKeyData)

print("Mario Bros Tweaks finished Loading.")