print("Mini mushroom Ring Attraction script Loading.")
print("Credit goes to Golden's Classic Ring Attraction script.")
/*
	Classic Ring Attraction script by Golden.
	Replicates how rings attract to the player in Sonic 3 and Sonic Mania.

	Lua people:
		To make your object also be effected by this script,
		just hook it into MobjThinker with the function A_ClassicRingAttract like so:

		addHook("MobjThinker", A_ClassicRingAttract, MT_CYBRAKDEMON)
*/

--Thank you so much for this script Golden, saved me from having to figure this on my own.
--I only need mini mario and luigi to have more range to colect rings and coins

--Don't run this if mario isn't loaded
if not MARIOSHIELDS then
	print("Mario Bros not detected! Mini Mushroom ring sttraction cancelled loading!")
	return
end

-- A list of objects to hook immediately during load.
local objects = {MT_RING, MT_FLINGRING, MT_COIN, MT_FLINGCOIN}

-- Change an object's type without deleting it.
-- Not globalising because I don't want to cause
-- people to actually use this.
local function changeObjectType(mo, newType)
	mo.type = newType

	local info = mobjinfo[newType]

	-- Set several mobj variables to their new defaults.
	mo.health = info.spawnhealth
	mo.reactiontime = info.reactiontime
	mo.radius = info.radius
	mo.height = info.height
	mo.flags = info.flags
end

-- Perform classic ring attraction. And many checks. Soo many checks.
function A_ClassicRingAttract(mo)
	-- Don't attract the rancid decomposing dead rings!
	if mo.health == 0 then
		mo.followmo = nil
		return
	end

	-- Check if player exists and is in range, and if so, link them to us.
	-- Otherwise, don't continue.
	if not mo.followmo or not mo.followmo.valid
	or not mo.followmo.player or not mo.followmo.player.valid then
		local target = mo.target -- Get current target, cause P_SupermanLook4Players overwrites it.
		local success = P_SupermanLook4Players(mo, 0, true)
		if success then
			if P_AproxDistance(P_AproxDistance(mo.x-mo.target.x, mo.y-mo.target.y), mo.z-mo.target.z) > 75*FRACUNIT then --smaller radius for mini mush
				mo.target = target
				return
			end
			mo.followmo = mo.target
			mo.target = target
		else
			return
		end
	end

	local followmo = mo.followmo

	-- If the player doesn't have electrical protection, fling off!
	if not (followmo.player.powers[pw_shield] == SH_MINI) then
		mo.flags = $ & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT & ~MF_NOGRAVITY
		mo.followmo = nil

		if mo.attractive then -- But only if we're too good for them.
			if mo.type == MT_RING then
				changeObjectType(mo, MT_FLINGRING)
				mo.fuse = 8*TICRATE
			end
			mo.attractive = false -- Someone forgot to put on makeup...
		end

		return
	else
		mo.attractive = true -- We're beautiful
	end

	mo.fuse = 0 -- Never disappear

	mo.flags = $ | MF_NOCLIP | MF_NOCLIPHEIGHT | MF_NOGRAVITY -- Go through everything

	mo.state = mo.state -- Update state

	P_MoveOrigin(mo, mo.followmo.x, mo.followmo.y, mo.followmo.z)

	return true -- Skip ring thinker.
end

-- For each object type in objects, hook A_ClassicRingAttract to their thinker.
-- Yes, this is valid Lua code.
for i, v in ipairs(objects) do
	addHook("MobjThinker", A_ClassicRingAttract, v)
end

print("Mini mushroom Ring Attraction script Finished Loading.")