print("Tag Patches Loading.")

--This script handles shield timers and fixes a fireflower bug when a skin is changed
--It may also be used for other features that run on a skin change

--===Variables===

local PlayerSkinMemory = {} --format: holds tables in this order: key=playernum in string form, value=skin (can be nil)

--fucking hold these bastard shield flags in this table
local shieldValue = {
	ArmaAndStack = (~SH_ARMAGEDDON ^^ SH_NOSTACK),
	JustArma = (~SH_ARMAGEDDON ^^ (SH_NOSTACK | SH_STACK))
}

--yeah this counts as skinj handling lol
local DisableNukes = CV_RegisterVar({
	name = "tu_disablenukes",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

--==Commands==
--simple command to remove a player's shield when called.
COM_AddCommand("tu_removemyshields", function(player)
	player.powers[pw_shield] = 0
end)

--===Functions===

local function TurnNukesToBubble(player)
	if (player.powers[pw_shield] == shieldValue["ArmaAndStack"]
	or player.powers[pw_shield] == shieldValue["JustArma"])
		player.powers[pw_shield] = $ & ~SH_ARMAGEDDON
		player.powers[pw_shield] = $ | SH_BUBBLEWRAP
		P_SpawnShieldOrb(player)
		chatprintf(player, "Huh, seems like it was actually a Bubble Shield...", true)
	end
end

--Make a function to block FireFlower usage
local function StopFireFlowerBug(player, playerIndex)
	if PlayerSkinMemory[playerIndex] != player.mo.skin then
		PlayerSkinMemory[playerIndex] = player.mo.skin --update the skin memory value
		--Player is on a new skin, remove fireflower and set new skin value
		if (player.powers[pw_shield] & SH_FIREFLOWER) then
			--flip the fireflower bit
			player.powers[pw_shield] = $ & ~SH_FIREFLOWER
			P_SpawnShieldOrb(player)
			chatprintf(player, "FireFlower Removed! You can shoot rings again!", true)
		end
	end
end

--handle skin change code
local function CheckSkinChange(player)
	if player.mo == nil or not TagUtilities.isTag then
		return --nil check, stops errors. also don't run if not tag.
	end
	local playerIndex = #player + 1 --add 1 to playerIndex to account for node 0, works fine even if player 1 is node 1
	StopFireFlowerBug(player, playerIndex)
end


--===Game hooks===

--this hook is basically being used to sync variables
addHook("NetVars", function(network)
	PlayerSkinMemory = network(PlayerSkinMemory) --sync the skinlist across other clients
end)

addHook("PlayerThink", function(player)
	CheckSkinChange(player)
end)

addHook("PreThinkFrame", do
	if DisableNukes.value == 1 then
		for player in players.iterate
			TurnNukesToBubble(player)
		end
	end
end)

addHook("PlayerJoin", function(playernum)
	table.insert(PlayerSkinMemory, playernum + 1, "sonic")
end)

addHook("PlayerQuit", function(player)
	table.remove(PlayerSkinMemory, #player + 1)
end)

print("Tag Patches is finished Loading.")